﻿using System;
using System.Web.UI;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace GetFeaturesByJavascriptSample
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/App_Data/Countries02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.StaticOverlay.Layers.Add("WorldLayer", worldLayer);
            }
        }

        protected void Map1_Click(object sender, MapClickedEventArgs e)
        {
            FeatureLayer worldLayer = (FeatureLayer)Map1.StaticOverlay.Layers["WorldLayer"];
            worldLayer.Open();
            Collection<Feature> selectedFeatures = worldLayer.QueryTools.GetFeaturesContaining(e.Position, new string[] {"RECID", "CNTRY_NAME" });
            worldLayer.Close();

            if (selectedFeatures.Count > 0)
            {
                var feature = selectedFeatures[0];
                string id = feature.Id;
                string name = feature.ColumnValues["CNTRY_NAME"];

                ScriptManager.RegisterStartupScript(UpdatePanel1, GetType(), "displayFunction", string.Format("displayFeature('{0}','{1}');", id, name), true);
            }
        }
    }
}